@use 'sass:map';
@use '@angular/material' as mat;
@use '../colors';

@use 'disabled-text';
@use 'highlight';
@use 'list-theme' as list;
@use 'menu-label';
@use 'menu';
@use 'missing-selection-theme' as missing;
@use 'standard-hover';
@use 'status';
@use 'slides';
@use 'annotation-loading-indicator';

@mixin set-colors($theme) {
  // config
  $config: mat.get-color-config($theme);
  // palette colors
  $primary-palette: map.get($config, 'primary');
  $accent-palette: map.get($config, 'accent');
  $warn-palette: map.get($config, 'warn');

  // palette fore- and background
  $foreground-palette: map.get($config, foreground);
  $background-palette: map.get($config, background);

  // primary colors
  $primary-color: mat.get-color-from-palette($primary-palette); // default should be 500
  $primary-color-100: mat.get-color-from-palette($primary-palette, 100);
  $primary-color-200: mat.get-color-from-palette($primary-palette, 200);
  $primary-color-400: mat.get-color-from-palette($primary-palette, 400);

  // primary contrast color
  $primary-contrast-color: mat.get-color-from-palette($primary-palette, default-contrast);

  // warn colors
  $warn-color-500: mat.get-color-from-palette($warn-palette, 500);
  $warn-color-800: mat.get-color-from-palette($warn-palette, 800);
  $warn-color-A700: mat.get-color-from-palette($warn-palette, A700);

  // dark gray colors
  $dark-gray-color-500: mat.get-color-from-palette(colors.$emp-dark-gray, 500);

  // green colors
  $green-color-900: mat.get-color-from-palette(colors.$emp-green, 900);

  // text
  $text-color: mat.get-color-from-palette($foreground-palette, text);
  $disabled-text-color: mat.get-color-from-palette($foreground-palette, disabled-text);
  $dark-text: colors.$dark-primary-text;

  $hover-background-color: mat.get-color-from-palette($background-palette, hover, 0.62);
  $examination-border: 1px solid $hover-background-color;
  $background-raised-button-color: mat.get-color-from-palette($background-palette, raised-button);
  $annotation-loading-text-background-color: colors.$light-primary-text;

  $annotation-loading-text-transparency: 0.5;

  $single-list-item-background-color: mat.get-color-from-palette($background-palette, hover, 0.22);

  $disabled-list-item: mat.get-color-from-palette($foreground-palette, disabled);

  @include disabled-text.set-disabled-text-color($disabled-text-color);

  @include highlight.set-highlight-background($dark-gray-color-500, $hover-background-color);
  @include highlight.set-highlight-expansion-button-background($dark-gray-color-500, $dark-gray-color-500);
  @include highlight.set-highlight-examination-background($dark-gray-color-500, $text-color, $examination-border);

  @include list.set-background-color($single-list-item-background-color);
  @include list.set-list-item-disabled-color($disabled-list-item);

  @include menu-label.set-primary-background-color($primary-contrast-color, $primary-color);
  @include menu-label.set-button-background-color($background-raised-button-color);
  @include menu-label.set-checkbox-disabled-color(transparent);

  @include menu.set-border-box-shadow($primary-color);
  @include menu.set-menu-item-panel-color($primary-color-100, $background-raised-button-color);
  @include menu.set-menu-footer-color($primary-color-100);

  @include missing.set-missing-selection-color($dark-gray-color-500, $warn-color-A700);

  @include standard-hover.set-hover-color($primary-color-200, $primary-color-400, $dark-gray-color-500);

  @include status.set-done-status-color($green-color-900);
  @include status.set-failed-status-color($warn-color-800);
  @include status.set-partial-done-status-color($primary-color);
  @include status.set-cation-status-color(colors.$yellow);

  @include slides.set-deleted-fallback($warn-color-500);
  @include slides.set-slide-background-color($text-color);

  @include annotation-loading-indicator.set-annotation-loading-text-color($dark-text, $annotation-loading-text-background-color, $annotation-loading-text-transparency);
}
